<?php

// no direct access
defined('_JEXEC') or die('Restricted access');

class modMusColStatisticsHelper
{

	function getItems(&$params){
		
		global $mainframe;
		$_db	= & JFactory::getDBO();
		$user	= & JFactory::getUser();
		
		$criteria = $params->get( 'criteria' );
		$selector = $params->get( 'selector' );
		
		$num = $params->get( 'num_items' );
		
		$limit = ' LIMIT ' . $num ;
		
		$time = $params->get( 'time' ) ; // en hores
		$timeabs = $params->get( 'timeabs' ) ;
		
		switch($params->get( 'mode', 'relative' )){
			case 'absolute':
				switch($timeabs){
					case 'TODAY':
					$more_where = ' AND st.date_event BETWEEN "'.date('Y-m-d').' 00:00:00" AND NOW() ' ;
					break;
					case 'YESTERDAY':
					$more_where = ' AND st.date_event BETWEEN SUBDATE(CURDATE(),1) AND CURDATE() ' ;
					break;
					case 'WEEK':
					$weekstarts = $params->get( 'weekstarts' ) ;
					$today = (int)date('w') ;
					$diff = ($today - $weekstarts)%7 ;
					$more_where = ' AND st.date_event BETWEEN SUBDATE(CURDATE(),'.$diff.') AND NOW() ' ;
					break;
					case 'LASTWEEK':
					$weekstarts = $params->get( 'weekstarts' ) ;
					$today = (int)date('w') ;
					$diff = ($today - $weekstarts)%7 ;
					$more_where = ' AND st.date_event BETWEEN SUBDATE(CURDATE(),'.($diff + 7).') AND SUBDATE(CURDATE(),'.$diff.') ' ;
					break;
					case 'MONTH':
					$more_where = ' AND st.date_event BETWEEN "'.date('Y-m').'-01 00:00:00" AND NOW() ' ;
					break;
					case 'LASTMONTH':
					if((int)date('m') == 1){ $year = (int)date('Y') - 1 ; $month = 12 ;}
					else { $year = date('Y') ; $month = date('m') - 1 ; }
					$more_where = ' AND st.date_event BETWEEN "'.$year.'-'.$month.'-01 00:00:00" AND "'.date('Y-m').'-01 00:00:00" ' ;
					break;
					case 'YEAR':
					$more_where = ' AND st.date_event BETWEEN "'.date('Y').'-01-01 00:00:00" AND NOW() ' ;
					break;
					case 'LASTYEAR':
					$more_where = ' AND st.date_event BETWEEN "'.((int)date('Y') - 1).'-01-01 00:00:00" AND "'.date('Y').'-01-01 00:00:00" ' ;
					break;
				}
			break;
			case 'relative':default:
				if($time){
					$more_where = ' AND st.date_event > ( NOW() - INTERVAL '.$time.' ) ' ;
				}
			break;
		}
		
		
		$viewer = $params->get( 'filter_user' );
		if($viewer){
			if($user->id) $more_where .= ' AND st.user_id = ' . $user->id ;
			else $more_where .= ' AND 0 ' ; // retyurn NOTHING
		}
		
		$view = JRequest::getVar('view');
		$id = JRequest::getInt('id');
		
		$query = '' ;
		
		// artist_id is for everything, actually: artist, album, song
		if($params->get( 'artist_id' )){
			$reference_id = $params->get( 'artist_id' );
			$artist_id = $reference_id ;
			$album_id = $reference_id ;
		
		}
		else{
			
			switch($view){
				case 'artist': case 'songs': // we are viewing the ARTIST page
					$artist_id = $id ;
					
				break;
				
				case 'album': // we are viewing the ALBUM page
					
					$album_id = $id ;
					
					$query = ' SELECT artist_id FROM #__muscol_albums WHERE id = ' .$id ;
					$_db->setQuery($query);
					$artist_id = $_db->loadResult();
					
				break;
				
				case 'song': // we are viewing the SONG page
					
					$query = ' SELECT artist_id FROM #__muscol_songs WHERE id = ' .$id ;
					$_db->setQuery($query);
					$artist_id = $_db->loadResult();
					
					$query = ' SELECT album_id FROM #__muscol_songs WHERE id = ' .$id ;
					$_db->setQuery($query);
					$album_id = $_db->loadResult();
					
				break;
			}
			
			//print_r(str_replace("#_","jos",$query));echo "\n";
			//print_r(str_replace("#_","jos",$query2));echo "\n";
			
		}
				
		switch($criteria){
			case 1: // albums viewed
			
				switch($selector){
					case 'current_artist': case 'specific_artist':
						$where_selector = ' AND ar.id = ' . $artist_id ;
					break;
				}
			
				$query = 	' SELECT al.*, COUNT(st.id) AS howmuch, al.name as item_name, ar.artist_name FROM #__muscol_statistics as st '.
							' LEFT JOIN #__muscol_albums AS al ON al.id = st.reference_id ' .
							' LEFT JOIN #__muscol_artists AS ar ON ar.id = al.artist_id ' .
							' WHERE st.type = 1 ' .
							$more_where .
							$where_selector .
							' GROUP BY al.id ' .
							' ORDER BY howmuch DESC '
							;
			
			break;
			
			case 2: // artists viewed
			
				$query = 	' SELECT ar.*, COUNT(st.id) AS howmuch, ar.artist_name as item_name FROM #__muscol_statistics as st '.
							' LEFT JOIN #__muscol_artists AS ar ON ar.id = st.reference_id ' .
							' WHERE st.type = 2 ' .
							$more_where .
							' GROUP BY ar.id ' .
							' ORDER BY howmuch DESC '
							;
			
			break;
			
			case 3: case 4: case 6: // songs viewed OR played OR downloaded
			
				switch($selector){
					case 'current_artist': case 'specific_artist':
						$where_selector = ' AND ar.id = ' . $artist_id ;
					break;
					case 'current_album': case 'specific_album':
						$where_selector = ' AND al.id = ' . $album_id ;
					break;
				}
				
				$query = 	' SELECT s.*, COUNT(st.id) AS howmuch, s.name as item_name, ar.artist_name FROM #__muscol_statistics as st '.
							' LEFT JOIN #__muscol_songs AS s ON s.id = st.reference_id ' .
							' LEFT JOIN #__muscol_albums AS al ON al.id = s.album_id ' .
							' LEFT JOIN #__muscol_artists AS ar ON ar.id = s.artist_id ' .
							' WHERE st.type = ' . $criteria .
							$more_where .
							$where_selector .
							' GROUP BY s.id ' .
							' ORDER BY howmuch DESC '
							;
			
			break;
			
			case 5: // playlists viewed
				
				$query = 	' SELECT pl.*, COUNT(st.id) AS howmuch FROM #__muscol_statistics as st '.
							' LEFT JOIN #__muscol_playlists AS pl ON pl.id = st.reference_id ' .
							' WHERE st.type = 5 ' .
							$more_where .
							$where_selector .
							' GROUP BY pl.id ' .
							' ORDER BY howmuch DESC '
							;
			
			break;
			
			
		}


		$query = 	$query .
					$limit
					; 
					
		//print_r(str_replace("#_","jos",$query));
		
		$_db->setQuery( $query );
		$items = $_db->loadObjectList();
			
		
		return $items;

	}

}