<?php

// no direct access
defined('_JEXEC') or die('Restricted access');

class modMusColTopRatedAlbumsHelper
{

	var $top_rated_albums = null;
	
	function getAlbums(&$params)
	{
		global $mainframe;
		$_db	= & JFactory::getDBO();
		$model		= modMusColTopRatedAlbumsHelper::getModel();

		if (empty( $this->top_rated_albums )) {
			
			if($params->get( 'n_albums' )) $limit = $params->get( 'n_albums' );
			else $limit = 5;
			
			if($params->get( 'artist_id' )) $where_clause[] = " al.artist_id = " . $params->get( 'artist_id' ) . " " ;
			
			if ($params->get( 'genre_id' )) {
				$genre_id = $params->get( 'genre_id' );
				$model->getDescendantsId($genre_id); 
				$descendants = $model->descendantsId;
				$descendants[] = $genre_id ;
				$genre_clause = ' ( al.genre_id = ' . implode(' OR al.genre_id = ',$descendants) . ' ) ';
				$where_clause[] = $genre_clause;
			}
			
			$format_id = $params->get( 'format_id' );
			if($format_id) $where_clause[] = '(al.format_id = '.$format_id.' OR f.display_group = '.$format_id.')' ;
			
			$where_clause = (count($where_clause) ? ' WHERE '.implode(' AND ', $where_clause) : '');
			
			$criteria = $params->get( 'criteria' );
			
			if($criteria){

				$query = 	' SELECT al.*,al.points as points_to_display, ar.artist_name FROM #__muscol_albums as al '.
							' LEFT JOIN #__muscol_format as f ON f.id = al.format_id '.
							' LEFT JOIN #__muscol_artists as ar ON ar.id = al.artist_id '.
							$where_clause .
							' ORDER BY points_to_display DESC '.
							' LIMIT '. $limit;
			}
			else{
						
				$query = 	' SELECT al.*, ar.artist_name, AVG(ra.points) as points_to_display FROM #__muscol_albums as al '.
							' LEFT JOIN #__muscol_format as f ON f.id = al.format_id '.
							' LEFT JOIN #__muscol_artists as ar ON ar.id = al.artist_id '.
							' LEFT JOIN #__muscol_ratings as ra ON ra.album_id = al.id '.
							$where_clause .
							' GROUP BY al.id ' .
							' ORDER BY points_to_display DESC '.
							' LIMIT '. $limit;
			}
			
			$_db->setQuery( $query );
			$this->top_rated_albums = $_db->loadObjectList();
		}
		return $this->top_rated_albums;

	}
	
	function getModel()
	{
		if (!class_exists( 'ArtistsModelSearch' ))
		{
			// Build the path to the model based upon a supplied base path
			$path = JPATH_SITE.DS.'components'.DS.'com_muscol'.DS.'models'.DS.'search.php';
			$false = false;

			// If the model file exists include it and try to instantiate the object
			if (file_exists( $path )) {
				require_once( $path );
				if (!class_exists( 'ArtistsModelSearch' )) {
					JError::raiseWarning( 0, 'Model class ArtistsModelSearch not found in file.' );
					return $false;
				}
			} else {
				JError::raiseWarning( 0, 'Model ArtistsModelSearch not supported. File not found.' );
				return $false;
			}
		}

		$model = new ArtistsModelSearch();
		
		return $model;
	}

}