<?php
defined('_JEXEC') or die('Restricted access');

class modXMovieFCEHelper {
	private $_num_movies;
	private $_movies_per_row;
	private $_category_id;
	private $_sort_method;
	private $_query;
	private $_data;
	private $_div_width;
	private $_moduleclass_sfx;
	private $_show_thumb;
	private $_show_name;
	private $_show_quicktake;
	private $_show_date;
	private $_show_hits;
	private $_thumb_width;
	private $_thumb_height;
	private $_catslug;
	private $_movslug;
	private $_params;
			
	public function __construct(&$params) {			
		$this->_num_movies = $params->get('num_movies', 5);
		$this->_category_id = $params->get('cat_id', 1);
		$this->_movie_id = $params->get('movie_id');
		$this->_sort_method = $params->get('sort_method');
		$this->_movies_per_row = $params->get('movies_per_row');
		$this->_moduleclass_sfx = $params->get('moduleclass_sfx');
		$this->_show_thumb = $params->get('show_thumb');
		$this->_show_name = $params->get('show_name');
		$this->_show_quicktake = $params->get('show_quicktake');
		$this->_show_date = $params->get('show_date');
		$this->_show_hits = $params->get('show_hits');
		$this->_thumb_width = $params->get('thumb_width');
		$this->_thumb_height = $params->get('thumb_height');
		$this->_div_width = "";
		$this->_show_arrows = $params->get('show_arrows', 0);
		$this->_params = $params;
	}
		
	public function getList() {
		$list = array();
		$db =& JFactory::getDBO();
		
		if(!$this->_query) {
			$query = $this->_buildQuery();
		} else {
			$query = $this->_query;
		}
		
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		
		if(!$this->_catslug) {
			$this->_catslug = MovieHelper::getCategorySlug();
		}
		
		if(!$this->_movslug) {
			$this->_movslug = MovieHelper::getMovieSlug();
		}
		
		$count = count($rows);
		$cTime = time();
		for($i = 0; $i < $count; $i++) {
			$rows[$i]->slug = $rows[$i]->id . ':' . $this->_movslug;
			$rows[$i]->catslug = $rows[$i]->cid . ':' . $this->_catslug;
			$user =& JFactory::getUser($rows[$i]->submitter);
			$rows[$i]->submitter = $user->username;
			$rows[$i]->itemid = MovieHelper::getXMovieItemId($rows[$i]->cid);

			$link = $this->_show_arrows;
			if($this->_params->get('show_movie', 0)) {
				$randCount = rand(0, $cTime);
				$rows[$i]->embed = MovieHelper::getShadowboxCode($rows[$i], $randCount, $link);
			}
		}
		
		return $rows;
	}
	
	public function getParams() {
		$paramslist = array();
		
		$paramslist['movies_per_row'] = $this->_movies_per_row;
		$paramslist['div_width'] = $this->_getDivWidth();
		$paramslist['moduleclass_sfx'] = $this->_moduleclass_sfx;
		$paramslist['show_thumb'] = $this->_show_thumb;
		$paramslist['show_name'] = $this->_show_name;
		$paramslist['show_quicktake'] = $this->_show_quicktake;
		$paramslist['show_date'] = $this->_show_date;
		$paramslist['show_hits'] = $this->_show_hits;
		$paramslist['thumb_width'] = $this->_thumb_width;
		$paramslist['thumb_height'] = $this->_thumb_height;
		
		return $paramslist;
	}
	
	public function _getDivWidth() {
		$this->_div_width = intval(100 / intval($this->_movies_per_row));
		$browser = MovieHelper::getBrowserType();
		if($browser['browser'] == 'IE') {
			$this->_div_width = $this->_div_width - 1;
		}
		return $this->_div_width;
	}
	
	private function _buildQuery() {
		if (!$this->_query) {					
			$this->_query = "SELECT * FROM #__xmovie_movies WHERE published = '1'";
			
			if(!empty($this->_category_id) && $this->_category_id != 1) {
				$this->_query .=  " AND cid = '{$this->_category_id}'";
			}
			
			$this->_query .= MovieHelper::getAccessLevel();
			
			switch($this->_sort_method) {
				case 'popular':
					$this->_query .= " ORDER BY hits DESC";
					break;
				case 'oldest':
					$this->_query .= " ORDER BY creation_date ASC";
					break;
				case 'random':
					$this->_query .= " ORDER BY RAND()";
					break;
				case 'newest':
				default:
					$this->_query .= " ORDER BY creation_date DESC";
					break;
			}
			
			$this->_query .= " LIMIT {$this->_num_movies}";			
		}

		return $this->_query;

	}
}	
?>