<?php
defined('_JEXEC') or die('Restricted access');

class modXMovieJScrollerHelper {
	private $_moduleclass_sfx;
	private $_number_movie;	
	private $_number_to_view;
	private $_category_id;
	private $_scroll_sort_method;
	private $_scroll_direction;
	private $_scroll_loop;
	private $_scroll_speed;
	private $_scroll_easing;
	private $_show_movie_name;
	private $_show_date;
	private $_show_hits;
	private $_show_category;
	private $_category_list;
	private $_thumb_width;
	private $_thumb_height;
	private $_query;
	private $_catslug;
	private $_collslug;
	private $_catnames;
	private $_enable_css;
	private $_auto_scroll;
	private $_auto_scroll_step;
	private $_auto_scroll_interval;
	private $_auto_scroll_autopause;
	private $_load_jquery;
		
	public function __construct(&$params) {		
		global $scroller_id;
		
		$this->slideid	= ++$scroller_id;			

		$this->_moduleclass_sfx			= $params->get('moduleclass_sfx', '');
		$this->_number_movie			= $params->get('number_movie', 5);	
		$this->_number_to_view			= $params->get('number_to_view', 5);
		$this->_category_id				= (int)$params->get('category_id', 1);
		$this->_scroll_sort_method		= $params->get('scroll_sort_method', 'random');
		$this->_scroll_direction		= $params->get('scroll_direction', 'vertical');
		$this->_scroll_loop				= $params->get('scroll_loop', 0);
		$this->_scroll_speed			= $params->get('scroll_speed', 400);
		$this->_scroll_easing			= $params->get('scroll_easing', 'swing');
		$this->_show_movie_name			= $params->get('show_movie_name', 1);
		$this->_show_date				= $params->get('show_date', 0);
		$this->_show_hits				= $params->get('show_hits', 1);
		$this->_show_category			= $params->get('show_category', 0);
		$this->_auto_scroll				= $params->get('auto_scroll', 0);
		$this->_auto_scroll_step		= $params->get('auto_scroll_step', 1);
		$this->_auto_scroll_interval	= $params->get('auto_scroll_interval', 1000);
		$this->_auto_scroll_autopause	= $params->get('auto_scroll_autopause', true);
		$this->_thumb_width 			= $params->get('thumb_width', 75);
		$this->_thumb_height 			= $params->get('thumb_height', 75);
		$this->_enable_css				= $params->get('enable_css', 0);
		$this->_load_jquery				= $params->get('load_jquery', 0);
	}
	
	public function getList() {
		$list = array();
		$db =& JFactory::getDBO();
		
		if(!$this->_query) {
			$query = $this->_buildQuery();
		} else {
			$query = $this->_query;
		}
		
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		
		if(!$this->_catslug) {
			$this->_catslug = MovieHelper::getCategorySlug();
		}
		
		if(!$this->_collslug) {
			$this->_collslug = MovieHelper::getMovieSlug();
		}
		
		$count = count($rows);
		for($i = 0; $i < $count; $i++) {
			$rows[$i]->slug = $rows[$i]->id . ':' . $this->_collslug;
			$rows[$i]->catslug = $rows[$i]->cid . ':' . $this->_catslug;
			$rows[$i]->itemid = MovieHelper::getXMovieItemId($rows[$i]->cid);
		}
		
		$catNames = $this->_getCategories();

		foreach ($catNames as $catName) {
			$this->_catnames[$catName['id']] = $catName['name'];
		}
		
		return $rows;
	}
	
	public function getCatNames() {
		return $this->_catnames;
	}
		
	public function getParams() {
		$showParams = array();
		
		$showParams['moduleclass_sfx']		= $this->_moduleclass_sfx;
		$showParams['number_movie']			= $this->_number_movie;	
		$showParams['number_to_view']		= $this->_number_to_view;
		$showParams['category_id']			= $this->_category_id;
		$showParams['scroll_sort_method']	= $this->_scroll_sort_method;
		$showParams['scroll_direction']		= $this->_scroll_direction;
		$showParams['scroll_loop']			= $this->_scroll_loop;
		$showParams['scroll_speed']			= $this->_scroll_speed;
		$showParams['scroll_easing']		= $this->_scroll_easing;
		$showParams['show_movie_name']		= $this->_show_movie_name;
		$showParams['show_date']			= $this->_show_date;
		$showParams['show_hits']			= $this->_show_hits;
		$showParams['show_category']		= $this->_show_category;
		$showParams['thumb_width'] 			= $this->_thumb_width;
		$showParams['thumb_height'] 		= $this->_thumb_height;
		$showParams['enable_css']			= $this->_enable_css;		
		
		return $showParams;
	}
				
	public function addStyleScripts($layout) {
		$document = &JFactory::getDocument();			

		if($this->_load_jquery) {
			$document->addScript(JURI::root(true).'/components/com_xmovie/js/jquery.js');
		}

		$document->addScript(JURI::root(true).'/modules/mod_xmovie_jscroller/lib/jquery.tools.min.js');
		
		switch($layout) {			
			case 'vertical':
				$document->addStyleSheet(JURI::root(true).'/modules/mod_xmovie_jscroller/css/style-vert.css');
				break;
			case 'horizontal':
			default:
				$document->addStyleSheet(JURI::root(true).'/modules/mod_xmovie_jscroller/css/style-horiz.css');
				break;
		}
		
	}
	
	public function addInitScript() {
		$script = '';
		
		if($this->_scroll_direction == "horizontal") {
			$theDiv = "scrollable";
			$direction = "false";
		} else {
			$theDiv = "scrollable-vert";
			$direction = "true";
		}
		
		if($this->_scroll_loop) {
			$loop = "true";
		} else {
			$loop = "false";
		}
		
		if($this->_auto_scroll_autopause) {
			$autopause = "true";
		} else {
			$autopause = "false";
		}
		
		if($this->_auto_scroll) {
		
			$autoscroll = ".autoscroll({
					steps: {$this->_auto_scroll_step},
					mousewheel: true,
					interval: {$this->_auto_scroll_interval},
					autoplay: true,
					autopause: {$autopause}
			 	})";
		} else {
			$autoscroll = "";
		}
		
		$script = "jQuery(document).ready(function($) {         
         
    		// initialize scrollable  
    		$(\"div.".$theDiv."\").scrollable({  
        		size: ".$this->_number_to_view.",
        		loop: ".$loop.",
    			circular: ".$loop.",
        		speed: ".$this->_scroll_speed.",
        		vertical: ".$direction.",
        		easing: \"".$this->_scroll_easing."\"

    		}){$autoscroll};     
     
		});";
		/*
		$script = "jQuery(document).ready(function($) {         
         
    		// initialize scrollable  
    		$(\"div.".$theDiv."\").scrollable({  
        		size: ".$this->_number_to_view.",
        		loop: ".$loop.",
        		speed: ".$this->_scroll_speed.",
        		vertical: ".$direction.",
        		easing: \"".$this->_scroll_easing."\"
         
    			// use mousewheel plugin 
    		}).mousewheel();     
     
		});";
		*/
		$document = &JFactory::getDocument();
		$document->addScriptDeclaration($script);
	}
	
	private function _buildQuery() {
		if (!$this->_query) {					
			$this->_query = "SELECT * FROM #__xmovie_movies WHERE published = '1'";
			
			if(!empty($this->_category_id) && $this->_category_id != 1) {
				$catIds = $this->_getCategoriesIDs();
				
				if(count($catIds) > 0) {
					$catlist = array();
					foreach($catIds as $catId) {
						$catlist[] = " cid='{$catId}'";					
					}	
					$this->_query .= ' AND ('. implode(' OR ', $catlist).')';				
				}
			}
			
			$this->_query .= MovieHelper::getAccessLevel();
			
			switch($this->_scroll_sort_method) {
				case 'popular':
					$this->_query .= " ORDER BY hits DESC";
					break;
				case 'oldest':
					$this->_query .= " ORDER BY creation_date ASC";
					break;
				case 'random':
					$this->_query .= " ORDER BY RAND()";
					break;
				case 'newest':
				default:
					$this->_query .= " ORDER BY creation_date DESC";
					break;
			}
			
			$this->_query .= " LIMIT {$this->_number_movie}";			
		}

		return $this->_query;
	}
	
	/**
	 *  Function to get all sub cagegories ids in the current categories that is allowed for the 
	 *  visitors access level.
	 *  
	 *  @return catids The sub category ids
	 */
	private function _getCategoriesIDs() {		
		$catids = array();
		$rows = array();
		$access = MovieHelper::getAccessLevel();

		if(empty($this->_catids)) {
			if($this->_category_id == 0) {
				$this->_category_id = 1;
			}
			
			$catids[] = $this->_category_id;
			$query = "SELECT id FROM #__xmovie_categories WHERE published = '1' AND pid= '{$this->_category_id}'".$access;
			$db =& JFactory::getDBO();
			$db->setQuery($query);
			$rows = $db->loadResultArray();

			while(count($rows) > 0) {
				$catArray = array();				
				
				foreach($rows as $row) {
					$catids[] = $row;
					$catArray[] = " pid='{$row}'";					
				}
				
				$query = "SELECT id FROM #__xmovie_categories WHERE published = '1'";
				if(count($catArray) > 0) {
					$query .= ' AND ('. implode(' OR ', $catArray).')';
				}

				$query .= $access;
				$db->setQuery($query);
				$rows = array();
				$rows = $db->loadResultArray();	
			}
		} 

		if(count($catids) > 0) {
			$this->_catids = $catids;
		}

		return $this->_catids;

	}
	
	/**
	 *  Function to get all sub cagegories ids and names in the current categories that is allowed for the 
	 *  visitors access level.
	 *  
	 *  @return catids The sub category ids
	 */
	private function _getCategories() {		
		$catids = array();
		$rows = array();
		$access = MovieHelper::getAccessLevel();

		if($this->_category_id == 0) {
			$this->_category_id = 1;
		}
			
		$catids[0] = array("id" => $this->_category_id, "name" => "");
		$query = "SELECT id, name FROM #__xmovie_categories WHERE published = '1' AND pid= '{$this->_category_id}'".$access;
		$db =& JFactory::getDBO();
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$count = 1;
		while(count($rows) > 0) {
			$catArray = array();				
				
			foreach($rows as $row) {
				$catids[$count] = array("id" => $row->id, "name" => $row->name);
				$catArray[] = " pid='{$row->id}'";
				$count++;				
			}
				
			$query = "SELECT id, name FROM #__xmovie_categories WHERE published = '1'";
			if(count($catArray) > 0) {
				$query .= ' AND ('. implode(' OR ', $catArray).')';
			}

			$query .= $access;
			$db->setQuery($query);
			$rows = array();
			$rows = $db->loadObjectList();	
		}
		return $catids;

	}
}
?>