<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @module XMovie Menu
 * @copyright Copyright (C) Dana Harris optikool.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.base.tree');
jimport('joomla.utilities.simplexml');

class modXMovieMenuHelper {

	private $_moduleclass_sfx;
	private $_show_main_level;
	private $_show_first_level_only;
	private $_main_level_name;
	private $_sort_method;
	private $_query;
	private $_active;
	private $_items;
	private $_params;

	public function __construct(&$params) {
		$this->_params = $params;
		$this->_moduleclass_sfx = $params->get('moduleclass_sfx', '');		
		$this->_show_main_level = $params->get('show_main_level', 0);
		$this->_show_first_level_only = $params->get('show_first_level_only', 1);
		$this->_main_level_name = $params->get('main_level_name', '');
		$this->_sort_method = $params->get('sort_method');
		$this->_active = modXMovieMenuHelper::setParams();

		modXMovieMenuHelper::getList();
		
	}
	
	public function setParams() {
		
		if (JRequest::getVar('option') == "com_xmovie") {
			$ctrl = JRequest::getVar('view');
			$id = JRequest::getVar('id');

			if ($ctrl == "category" || $ctrl == "categories") {
				list($id, $name) = split(':', $id);
				return $id;
			} else if($ctrl == "main") {
				return "1";
			} else {
				if(isset($id)) {
					$cid = MovieHelper::getCategory($id);
					return $cid->cid;
				} else {
					return "";
				}
			} 
		} else {
			return "";
		}
	}

	public function getList() {
		global $mainframe;

		$list = array();
		$db =& JFactory::getDBO();
		
		if(!$this->_query) {
			$query = $this->_buildQuery();
			$this->_query = $query;
		} else {
			$query = $this->_query;
		}
		
		
		
		$db->setQuery($this->_query);
		if(!$rows = $db->loadObjectList()) {
			$rows = array();
		}
		
		if(!$this->_show_first_level_only) {
			$tree = array();
			$rows = MovieHelper::getCategoryTree($rows, $tree, 0, -1);
		}
		
		return $rows;
	}
		
	public function getParams() {
		$paramslist = array();

		$paramslist['moduleclass_sfx'] = $this->_moduleclass_sfx;
		$paramslist['show_main'] = $this->_show_main_level;
		$paramslist['main_name'] = $this->_main_level_name;
		$paramslist['active'] = $this->_active;

		return $paramslist;
	}

	private function _buildQuery() {		
		$query = 	"SELECT a.*, c.countid AS countid";
		$query .=	" FROM #__xmovie_categories AS a";
		$query .=	" JOIN (SELECT c.pid, count(*) AS countid";
		$query .=	" FROM #__xmovie_categories AS c";
		$query .=	" GROUP BY c.pid) AS c";
		$query .=	" ON a.pid = c.pid";
		$query .=	" WHERE published = 1";
		if($this->_show_first_level_only) {
			$query .= " AND a.pid = '1'";
		} 
			
		$query .= MovieHelper::getAccessLevel();
		
		$query .= " ORDER BY ordering";
		
		return $query;
	}
}
?>